use "$dir\DataSCLB.dta", clear 
	count if Study_Arm==0
	local ncon = r(N)
	count if Study_Arm==1
	local n_cct = r(N)
	count if Study_Arm==2
	local n_mt = r(N)	
	local samplesize `n_cct' `n_mt'
	foreach s of local samplesize {
		use "$dir\DataSCLB.dta", clear 
		// Estimate
			isd_pval EL_EGRA_PCA_Index, r(250) mt(1.5) cct(0.5) ssize_c(`ncon') ssize_t(`s') se bsreps(250) 
		// Save Results
			gen aux = (0 > = lbs_ci_MT & 0 <= ubs_ci_MT) 
			mat J_`s' = J(6,1,.)
			mat J_`s'[1,1] = 0.000
			local i = 2
			foreach var in isd_MT isd_MT_se {
				sum `var'
				mat J_`s'[`i',1] = r(mean)
				local i = 1+`i'
				mat J_`s'[`i',1] = r(sd)
				local i = 1+`i'
			}	
			sum aux 
			mat J_`s'[6,1] = r(mean)
	}
	/*
	use "$modified\EstData.dta" if Cohort==2 & Grade_Level_On_Track==3 & sample_X==1, clear // ONLY FOR COHORT 2
	count if Study_Arm==0
	local ncon = r(N)
	count if Study_Arm==1
	local n_cct = r(N)
	count if Study_Arm==2
	local n_mt = r(N)	
	*/
	clear
	set obs 6
	gen i = ""
	replace i = "Population impact standard deviation" in 1
	replace i = "Mean of data sample estimates" in 2
	replace i = "Std. Dev. of data sample estimates" in 3
	replace i = "Mean of boostrap standard errors" in 4
	replace i = "Std. dev. of bootstrap standard errors" in 5
	svmat J_`n_mt' 
	svmat J_`n_cct'
	drop in 6
	// Export	
	format J_`n_mt' J_`n_cct' %12.3fc
	local ncon2: di %12.0fc `ncon'
	local n_mt2: di %12.0fc `n_mt'
	local n_cct2: di %12.0fc `n_cct'	

	save "$output/AppendixTable5.dta", replace