******* Summary Table		
use "$output/Table7.dta", clear
	keep in 13/14	
	replace p_exp = "\quad Machine Learning" in 1
	tempfile fh1
	save `fh1'
	
use "$output/AppendixTable11.dta", clear
	keep in 13/14	
	replace p_exp = "\quad Conventional Method" in 1
	tempfile fh2
	save `fh2'	
	
use "$output/Table2.dta", clear
	keep in 13/14	
	replace p_exp = "Unadjusted FH Bounds" in 1
	count 
	local N = r(N) +1
	set obs `N'
	replace p_exp = "\textit{Removing Systematic Variation:}" in 3
	
	append using `fh1'
	append using `fh2'
	
gen blank = ""	
# delimit ;			
texsave p_exp FH_up_MT_Program_pt_st FH_lo_MT_Program_pt_st blank FH_up_CCT_Program_pt_st FH_lo_CCT_Program_pt_st using "$tables/ t_FH_Bounds_summary.tex", 
					replace align(rccccc) location(H) width(\textwidth) hlines(2)
					headerlines("& \multicolumn{2}{c}{Full-cost Program} & & \multicolumn{2}{c}{Reduced-cost Program} \\ 
					\cmidrule{2-3} \cmidrule{5-6} & Rank & Rank & & Rank & Rank \\ 
					& Preservation & Inversion & & Preservation   & Inversion \\
					& (1) & (2) & & (3) & (4) ") 
					size(small) frag nonames nofix ;
# delimit cr